List of all members
cgicc::FormEntry Class Reference

Class representing a single HTML form entry. More...

`#include <cgicc/FormEntry.h>`

## Public Member Functions
Constructors and Destructor
| FormEntry ()
| Default constructor. More...
| FormEntry (const std::string &name, const std::string &value)
| Create a new FormEntry. More...
| FormEntry (const FormEntry &entry)
| Copy constructor. More...
| ~FormEntry ()
| Destructor. More...
Overloaded Operators
bool | operator== (const FormEntry &entry) const
| Compare two FormEntrys for equality. More...
bool | operator!= (const FormEntry &entry) const
| Compare two FormEntrys for inequality. More...
FormEntry & | operator= (const FormEntry &entry)
| Assign one FormEntry to another. More...

## Accessor Methods
Information on the form element
std::string | getName () const
| Get the name of the form element. More...
std::string | getValue () const
| Get the value of the form element as a string. More...
std::string | operator* () const
| Get the value of the form element as a string. More...
std::string | getValue (std::string::size_type maxChars) const
| Get the value of the form element as a string. More...
std::string | getStrippedValue () const
| Get the value of the form element as a string. More...
std::string | getStrippedValue (std::string::size_type maxChars) const
| Get the value of the form element as a string. More...
long | getIntegerValue (long min=LONG_MIN, long max=LONG_MAX) const
| Get the value of the form element as an integer. More...
long | getIntegerValue (long min, long max, bool &bounded) const
| Get the value of the form element as an integer. More...
double | getDoubleValue (double min=-DBL_MAX, double max=DBL_MAX) const
| Get the value of the form element as a double. More...
double | getDoubleValue (double min, double max, bool &bounded) const
| Get the value of the form element as a double. More...
std::string::size_type | length () const
| Get the number of characters in the value of the form element. More...
bool | isEmpty () const
| Determine if this form element is empty. More...

## Detailed Description

Class representing a single HTML form entry.

FormEntry is an immutable class representing a single user entry in an HTML form element such as a text field, radio button, or a checkbox. A FormEntry is essentially a name/value pair, where the name is the name of the form element as specified in the HTML form itself, and the value is the user-entered or user-selected value.

If a `QUERY_STRING` contained the fragment `cgicc=yes` the corresponding FormEntry would have a name of `cgicc` and a value of `yes`

See also
  FormFile

Definition at line 70 of file FormEntry.h.

## Constructor & Destructor Documentation

## ◆ FormEntry() [1/3]

cgicc::FormEntry::FormEntry | ( |  | ) |
| inline

Default constructor.

Shouldn't be used.

Definition at line 85 of file FormEntry.h.

## ◆ FormEntry() [2/3]

cgicc::FormEntry::FormEntry | ( | const std::string & | name,
|  | const std::string & | value
| ) |  |
| inline

Create a new FormEntry.

This is usually not called directly, but by Cgicc.

Parameters

  name | The name of the form element
  value | The value of the form element

Definition at line 96 of file FormEntry.h.

## ◆ FormEntry() [3/3]

cgicc::FormEntry::FormEntry | ( | const FormEntry & | entry | ) |
| inline

Copy constructor.

Sets the name and value of this FormEntry to those of `entry`.

Parameters

  entry | The FormEntry to copy.

Definition at line 108 of file FormEntry.h.

## ◆ ~FormEntry()

cgicc::FormEntry::~FormEntry | ( |  | ) |
| inline

Destructor.

Delete this FormEntry object

Definition at line 117 of file FormEntry.h.

## Member Function Documentation

## ◆ getDoubleValue() [1/2]

double cgicc::FormEntry::getDoubleValue | ( | double | min,
|  | double | max,
|  | bool & | bounded
| ) |  | const

Get the value of the form element as a double.

No syntax checking is performed on the string value.

Parameters

  min | The minimum value to return.
  max | The maximum value to return.
  bounded | Set to `true` if the value was originally outside the limits, `false` otherwise

Returns
  The double value of the form element.

## ◆ getDoubleValue() [2/2]

double cgicc::FormEntry::getDoubleValue | ( | double | min = `-DBL_MAX`,
|  | double | max = `DBL_MAX`
| ) |  | const

Get the value of the form element as a double.

No syntax checking is performed on the string value.

Parameters

  min | The minimum value to return (optional).
  max | The maximum value to return (optional).

Returns
  The double value of the form element.

## ◆ getIntegerValue() [1/2]

long cgicc::FormEntry::getIntegerValue | ( | long | min,
|  | long | max,
|  | bool & | bounded
| ) |  | const

Get the value of the form element as an integer.

No syntax checking is performed on the string value.

Parameters

  min | The minimum value to return.
  max | The maximum value to return.
  bounded | Set to `true` if the value was originally outside the limits, `false` otherwise

Returns
  The integer value of the form element.

## ◆ getIntegerValue() [2/2]

long cgicc::FormEntry::getIntegerValue | ( | long | min = `LONG_MIN`,
|  | long | max = `LONG_MAX`
| ) |  | const

Get the value of the form element as an integer.

No syntax checking is performed on the string value.

Parameters

  min | The minimum value to return (optional).
  max | The maximum value to return (optional).

Returns
  The integer value of the form element.

## ◆ getName()

std::string cgicc::FormEntry::getName | ( |  | ) | const
| inline

Get the name of the form element.

The name of the form element is specified in the HTML form that called the CGI application.

Returns
  The name of the form element.

Definition at line 181 of file FormEntry.h.

## ◆ getStrippedValue() [1/2]

std::string cgicc::FormEntry::getStrippedValue | ( |  | ) | const
| inline

Get the value of the form element as a string.

The value returned will be stripped of all line breaks.

Returns
  The value of the form element, stripped of all line breaks.

Definition at line 223 of file FormEntry.h.

## ◆ getStrippedValue() [2/2]

std::string cgicc::FormEntry::getStrippedValue | ( | std::string::size_type | maxChars | ) | const
| inline

Get the value of the form element as a string.

The value returned will be stripped of all line breaks and truncated to a specific length.

Parameters

  maxChars | The maximum number of characters to return.

Returns
  The value of the form element, stripped of all line breaks and truncated to the specified length.

Definition at line 236 of file FormEntry.h.

## ◆ getValue() [1/2]

std::string cgicc::FormEntry::getValue | ( |  | ) | const
| inline

Get the value of the form element as a string.

The value returned may contain line breaks.

Returns
  The value of the form element.

Definition at line 191 of file FormEntry.h.

## ◆ getValue() [2/2]

std::string cgicc::FormEntry::getValue | ( | std::string::size_type | maxChars | ) | const
| inline

Get the value of the form element as a string.

The value returned will be truncated to a specific length. The value may contain line breaks.

Parameters

  maxChars | The maximum number of characters to return.

Returns
  The value of the form element, truncated to the specified length.

Definition at line 213 of file FormEntry.h.

## ◆ isEmpty()

bool cgicc::FormEntry::isEmpty | ( |  | ) | const
| inline

Determine if this form element is empty.

In an empty form element, length() == 0.

Returns
  `true` if this form element is empty, `false` otherwise.

Definition at line 311 of file FormEntry.h.

## ◆ length()

std::string::size_type cgicc::FormEntry::length | ( |  | ) | const
| inline

Get the number of characters in the value of the form element.

Note that a character may or may not equal one byte.

Returns
  The length of the value of the form element

Definition at line 301 of file FormEntry.h.

## ◆ operator!=()

bool cgicc::FormEntry::operator!= | ( | const FormEntry & | entry | ) | const
| inline

Compare two FormEntrys for inequality.

FormEntrys are equal if they have the same name and value.

Parameters

  entry | The FormEntry to compare to this one.

Returns
  `false` if the two FormEntrys are equal, `true` otherwise.

Definition at line 145 of file FormEntry.h.

## ◆ operator*()

std::string cgicc::FormEntry::operator* | ( |  | ) | const
| inline

Get the value of the form element as a string.

The value returned may contain line breaks.

Returns
  The value of the form element.

Definition at line 201 of file FormEntry.h.

References CardGameTools::getValue().

## ◆ operator=()

FormEntry & cgicc::FormEntry::operator= | ( | const FormEntry & | entry | ) |

Assign one FormEntry to another.

Sets the name and value of this FormEntry to those of `entry`.

Parameters

  entry | The FormEntry to copy.

Returns
  A reference to this.

## ◆ operator==()

bool cgicc::FormEntry::operator== | ( | const FormEntry & | entry | ) | const
| inline

Compare two FormEntrys for equality.

FormEntrys are equal if they have the same name and value.

Parameters

  entry | The FormEntry to compare to this one.

Returns
  `true` if the two FormEntrys are equal, `false` otherwise.

Definition at line 134 of file FormEntry.h.

References cgicc::stringsAreEqual().

The documentation for this class was generated from the following file:

- FormEntry.h